//#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <sys\cdefs.h>
#include <sys\types.h>

typedef  unsigned short     USHORT ;
typedef  unsigned char      UCHAR  ;
typedef  unsigned long      ULONG  ;
typedef           short     SHORT ;
typedef           char      CHAR  ;
typedef           long      LONG  ;

//#pragma pack(push,1)
//#pragma pack(8)

#define OID_802_3_CURRENT_ADDRESS               0x01010102

#define OID_802_11_BSSID                        0x0d010101
#define OID_802_11_SSID                         0x0d010102
#define OID_802_11_INFRASTRUCTURE_MODE          0x0d010108
#define OID_802_11_ADD_WEP                      0x0D010113
#define OID_802_11_REMOVE_WEP                   0x0D010114
#define OID_802_11_DISASSOCIATE                 0x0D010115
#define OID_802_11_BSSID_LIST                   0x0d010217
#define OID_802_11_AUTHENTICATION_MODE          0x0d010118
#define OID_802_11_PRIVACY_FILTER               0x0d010119
#define OID_802_11_BSSID_LIST_SCAN              0x0d01011A
#define OID_802_11_WEP_STATUS                   0x0d01011B
#define OID_802_11_ENCRYPTION_STATUS OID_802_11_WEP_STATUS
#define OID_802_11_ADD_KEY                      0x0d01011D
#define OID_802_11_REMOVE_KEY                   0x0d01011E
#define OID_802_11_ASSOCIATION_INFORMATION      0x0d01011F
#define OID_802_11_TEST                         0x0d010120
#define OID_802_11_CAPABILITY                   0x0d010122
#define OID_802_11_PMKID                        0x0d010123

#define NDIS_802_11_LENGTH_SSID 32
#define NDIS_802_11_LENGTH_RATES 8
#define NDIS_802_11_LENGTH_RATES_EX 16

typedef UCHAR NDIS_802_11_MAC_ADDRESS[6];

typedef unsigned long long ULONGULONG ;

typedef struct NDIS_802_11_SSID {
        ULONG SsidLength;
        UCHAR Ssid[NDIS_802_11_LENGTH_SSID];
} NDIS_802_11_SSID;

typedef LONG NDIS_802_11_RSSI;

typedef enum NDIS_802_11_NETWORK_TYPE {
        Ndis802_11FH,
        Ndis802_11DS,
        Ndis802_11OFDM5,
        Ndis802_11OFDM24,
        Ndis802_11NetworkTypeMax
} NDIS_802_11_NETWORK_TYPE;

typedef struct NDIS_802_11_CONFIGURATION_FH {
        ULONG Length;
        ULONG HopPattern;
        ULONG HopSet;
        ULONG DwellTime;
} NDIS_802_11_CONFIGURATION_FH;

typedef struct NDIS_802_11_CONFIGURATION {
        ULONG Length;
        ULONG BeaconPeriod;
        ULONG ATIMWindow;
        ULONG DSConfig;
        NDIS_802_11_CONFIGURATION_FH FHConfig;
} NDIS_802_11_CONFIGURATION;

typedef enum NDIS_802_11_NETWORK_INFRASTRUCTURE {
        Ndis802_11IBSS,
        Ndis802_11Infrastructure,
        Ndis802_11AutoUnknown,
        Ndis802_11InfrastructureMax
} NDIS_802_11_NETWORK_INFRASTRUCTURE;

typedef enum NDIS_802_11_AUTHENTICATION_MODE {
        Ndis802_11AuthModeOpen,
        Ndis802_11AuthModeShared,
        Ndis802_11AuthModeAutoSwitch,
        Ndis802_11AuthModeWPA,
        Ndis802_11AuthModeWPAPSK,
        Ndis802_11AuthModeWPANone,
        Ndis802_11AuthModeWPA2,
        Ndis802_11AuthModeWPA2PSK,
        Ndis802_11AuthModeMax
} NDIS_802_11_AUTHENTICATION_MODE;

typedef enum NDIS_802_11_WEP_STATUS {
        Ndis802_11WEPEnabled,
        Ndis802_11Encryption1Enabled = Ndis802_11WEPEnabled,
        Ndis802_11WEPDisabled,
        Ndis802_11EncryptionDisabled = Ndis802_11WEPDisabled,
        Ndis802_11WEPKeyAbsent,
        Ndis802_11Encryption1KeyAbsent = Ndis802_11WEPKeyAbsent,
        Ndis802_11WEPNotSupported,
        Ndis802_11EncryptionNotSupported = Ndis802_11WEPNotSupported,
        Ndis802_11Encryption2Enabled,
        Ndis802_11Encryption2KeyAbsent,
        Ndis802_11Encryption3Enabled,
        Ndis802_11Encryption3KeyAbsent
} NDIS_802_11_WEP_STATUS, NDIS_802_11_ENCRYPTION_STATUS;

typedef enum NDIS_802_11_PRIVACY_FILTER {
        Ndis802_11PrivFilterAcceptAll,
        Ndis802_11PrivFilter8021xWEP
} NDIS_802_11_PRIVACY_FILTER;

typedef UCHAR NDIS_802_11_RATES[NDIS_802_11_LENGTH_RATES];
typedef UCHAR NDIS_802_11_RATES_EX[NDIS_802_11_LENGTH_RATES_EX];

typedef struct NDIS_WLAN_BSSID_EX {
        ULONG Length;
        NDIS_802_11_MAC_ADDRESS MacAddress; /* BSSID */
        UCHAR Reserved[2];
        NDIS_802_11_SSID Ssid;
        ULONG Privacy;
        NDIS_802_11_RSSI Rssi;
        NDIS_802_11_NETWORK_TYPE NetworkTypeInUse;
        NDIS_802_11_CONFIGURATION Configuration;
        NDIS_802_11_NETWORK_INFRASTRUCTURE InfrastructureMode;
        NDIS_802_11_RATES_EX SupportedRates;
        ULONG IELength;
        UCHAR IEs[1];
} NDIS_WLAN_BSSID_EX;

typedef struct NDIS_802_11_BSSID_LIST_EX {
        ULONG NumberOfItems;
        NDIS_WLAN_BSSID_EX Bssid[1];
} NDIS_802_11_BSSID_LIST_EX;

typedef struct NDIS_802_11_FIXED_IEs {
        UCHAR Timestamp[8];
        USHORT BeaconInterval;
        USHORT Capabilities;
} NDIS_802_11_FIXED_IEs;

typedef struct NDIS_802_11_WEP {
        ULONG Length;
        ULONG KeyIndex;
        ULONG KeyLength;
        UCHAR KeyMaterial[1];
} NDIS_802_11_WEP;

typedef ULONG NDIS_802_11_KEY_INDEX;
typedef ULONGULONG NDIS_802_11_KEY_RSC;

typedef struct NDIS_802_11_KEY {
        ULONG Length;
        ULONG KeyIndex;
        ULONG KeyLength;
        NDIS_802_11_MAC_ADDRESS BSSID;
        NDIS_802_11_KEY_RSC KeyRSC;
        UCHAR KeyMaterial[1];
} NDIS_802_11_KEY ;

typedef struct NDIS_802_11_REMOVE_KEY {
        ULONG Length;
        ULONG KeyIndex;
        NDIS_802_11_MAC_ADDRESS BSSID;
} NDIS_802_11_REMOVE_KEY;

typedef struct NDIS_802_11_AI_REQFI {
        USHORT Capabilities;
        USHORT ListenInterval;
        NDIS_802_11_MAC_ADDRESS CurrentAPAddress;
} NDIS_802_11_AI_REQFI;

typedef struct NDIS_802_11_AI_RESFI {
        USHORT Capabilities;
        USHORT StatusCode;
        USHORT AssociationId;
} NDIS_802_11_AI_RESFI;

typedef struct NDIS_802_11_ASSOCIATION_INFORMATION {
        ULONG Length;
        USHORT AvailableRequestFixedIEs;
        NDIS_802_11_AI_REQFI RequestFixedIEs;
        ULONG RequestIELength;
        ULONG OffsetRequestIEs;
        USHORT AvailableResponseFixedIEs;
        NDIS_802_11_AI_RESFI ResponseFixedIEs;
        ULONG ResponseIELength;
        ULONG OffsetResponseIEs;
} NDIS_802_11_ASSOCIATION_INFORMATION;

typedef struct NDIS_802_11_AUTHENTICATION_ENCRYPTION {
        NDIS_802_11_AUTHENTICATION_MODE AuthModeSupported;
        NDIS_802_11_ENCRYPTION_STATUS EncryptStatusSupported;
} NDIS_802_11_AUTHENTICATION_ENCRYPTION;

typedef struct NDIS_802_11_CAPABILITY {
        ULONG Length;
        ULONG Version;
        ULONG NoOfPMKIDs;
        ULONG NoOfAuthEncryptPairSupported;
        NDIS_802_11_AUTHENTICATION_ENCRYPTION
                AuthenticationEncryptionSupported[1];
} NDIS_802_11_CAPABILITY;

typedef UCHAR NDIS_802_11_PMKID_VALUE[16];

typedef struct BSSID_INFO {
        NDIS_802_11_MAC_ADDRESS BSSID;
        NDIS_802_11_PMKID_VALUE PMKID;
} BSSID_INFO;

typedef struct NDIS_802_11_PMKID {
        ULONG Length;
        ULONG BSSIDInfoCount;
        BSSID_INFO BSSIDInfo[1];
} NDIS_802_11_PMKID;

typedef enum NDIS_802_11_STATUS_TYPE {
        Ndis802_11StatusType_Authentication,
        Ndis802_11StatusType_PMKID_CandidateList = 2,
        Ndis802_11StatusTypeMax
} NDIS_802_11_STATUS_TYPE;

typedef struct NDIS_802_11_STATUS_INDICATION {
        NDIS_802_11_STATUS_TYPE StatusType;
} NDIS_802_11_STATUS_INDICATION;

typedef struct PMKID_CANDIDATE {
        NDIS_802_11_MAC_ADDRESS BSSID;
        ULONG Flags;
} PMKID_CANDIDATE;

#define NDIS_802_11_PMKID_CANDIDATE_PREAUTH_ENABLED 0x01

typedef struct NDIS_802_11_PMKID_CANDIDATE_LIST {
        ULONG Version;
        ULONG NumCandidates;
        PMKID_CANDIDATE CandidateList[1];
} NDIS_802_11_PMKID_CANDIDATE_LIST;

typedef struct NDIS_802_11_AUTHENTICATION_REQUEST {
        ULONG Length;
        NDIS_802_11_MAC_ADDRESS Bssid;
        ULONG Flags;
} NDIS_802_11_AUTHENTICATION_REQUEST;

#define NDIS_802_11_AUTH_REQUEST_REAUTH                 0x01
#define NDIS_802_11_AUTH_REQUEST_KEYUPDATE              0x02
#define NDIS_802_11_AUTH_REQUEST_PAIRWISE_ERROR         0x06
#define NDIS_802_11_AUTH_REQUEST_GROUP_ERROR            0x0E


int main(int argc,char **argv)
{
/*
typedef struct NDIS_802_11_SSID {
        ULONG SsidLength;
        UCHAR Ssid[NDIS_802_11_LENGTH_SSID];
} NDIS_802_11_SSID;
*/

    printf("\nNDIS_802_11_SSID\n");
    printf("    SsidLength  : %d\n",offsetof(NDIS_802_11_SSID,SsidLength));
    printf("    Ssid        : %d\n",offsetof(NDIS_802_11_SSID,Ssid));


/*
typedef struct NDIS_802_11_CONFIGURATION_FH {
        ULONG Length;
        ULONG HopPattern;
        ULONG HopSet;
        ULONG DwellTime;
} NDIS_802_11_CONFIGURATION_FH;
*/

    printf("\nNDIS_802_11_CONFIGURATION_FH\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_CONFIGURATION_FH,Length));
    printf("    HopPattern  : %d\n",offsetof(NDIS_802_11_CONFIGURATION_FH,HopPattern));
    printf("    HopSet      : %d\n",offsetof(NDIS_802_11_CONFIGURATION_FH,HopSet));
    printf("    DwellTime   : %d\n",offsetof(NDIS_802_11_CONFIGURATION_FH,DwellTime));

/*
typedef struct NDIS_802_11_CONFIGURATION {
        ULONG Length;
        ULONG BeaconPeriod;
        ULONG ATIMWindow;
        ULONG DSConfig;
        NDIS_802_11_CONFIGURATION_FH FHConfig;
} NDIS_802_11_CONFIGURATION;
*/

    printf("\nNDIS_802_11_CONFIGURATION\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_CONFIGURATION,Length));
    printf("    BeaconPeriod: %d\n",offsetof(NDIS_802_11_CONFIGURATION,BeaconPeriod));
    printf("    ATIMWindow  : %d\n",offsetof(NDIS_802_11_CONFIGURATION,ATIMWindow));
    printf("    DSConfig    : %d\n",offsetof(NDIS_802_11_CONFIGURATION,DSConfig));
    printf("    FHConfig    : %d\n",offsetof(NDIS_802_11_CONFIGURATION,FHConfig));


/*
typedef struct NDIS_WLAN_BSSID_EX {
        ULONG Length;
        NDIS_802_11_MAC_ADDRESS MacAddress;
        UCHAR Reserved[2];
        NDIS_802_11_SSID Ssid;
        ULONG Privacy;
        NDIS_802_11_RSSI Rssi;
        NDIS_802_11_NETWORK_TYPE NetworkTypeInUse;
        NDIS_802_11_CONFIGURATION Configuration;
        NDIS_802_11_NETWORK_INFRASTRUCTURE InfrastructureMode;
        NDIS_802_11_RATES_EX SupportedRates;
        ULONG IELength;
        UCHAR IEs[1];
} NDIS_WLAN_BSSID_EX;
*/

    printf("\nNDIS_WLAN_BSSID_EX\n");
    printf("    Length      : %d\n",offsetof(NDIS_WLAN_BSSID_EX,Length));
    printf("    MacAddress  : %d\n",offsetof(NDIS_WLAN_BSSID_EX,MacAddress));
    printf("    Reserved    : %d\n",offsetof(NDIS_WLAN_BSSID_EX,Reserved));
    printf("    Ssid        : %d\n",offsetof(NDIS_WLAN_BSSID_EX,Ssid));
    printf("    Privacy     : %d\n",offsetof(NDIS_WLAN_BSSID_EX,Privacy));
    printf("    Rssi        : %d\n",offsetof(NDIS_WLAN_BSSID_EX,Rssi));
    printf("    NetworkTIU  : %d\n",offsetof(NDIS_WLAN_BSSID_EX,NetworkTypeInUse));
    printf("    Configuratio: %d\n",offsetof(NDIS_WLAN_BSSID_EX,Configuration));
    printf("    Infrastruct : %d\n",offsetof(NDIS_WLAN_BSSID_EX,InfrastructureMode));
    printf("    SupportedRa : %d\n",offsetof(NDIS_WLAN_BSSID_EX,SupportedRates));
    printf("    IELength    : %d\n",offsetof(NDIS_WLAN_BSSID_EX,IELength));
    printf("    IEs[]       : %d\n",offsetof(NDIS_WLAN_BSSID_EX,IEs));

/*
typedef struct NDIS_802_11_BSSID_LIST_EX {
        ULONG NumberOfItems;
        NDIS_WLAN_BSSID_EX Bssid[1];
} NDIS_802_11_BSSID_LIST_EX;
*/
    printf("\nNDIS_802_11_BSSID_LIST_EX\n");
    printf("    NumberOfItem: %d\n",offsetof(NDIS_802_11_BSSID_LIST_EX,NumberOfItems));
    printf("    Bssid[]     : %d\n",offsetof(NDIS_802_11_BSSID_LIST_EX,Bssid));

/*
typedef struct NDIS_802_11_FIXED_IEs {
        UCHAR Timestamp[8];
        USHORT BeaconInterval;
        USHORT Capabilities;
} NDIS_802_11_FIXED_IEs;
*/
    printf("\nNDIS_802_11_FIXED_IEs\n");
    printf("    Timestamp[8]: %d\n",offsetof(NDIS_802_11_FIXED_IEs,Timestamp));
    printf("    BeaconInterv: %d\n",offsetof(NDIS_802_11_FIXED_IEs,BeaconInterval));
    printf("    Capabilities: %d\n",offsetof(NDIS_802_11_FIXED_IEs,Capabilities));

/*
typedef struct NDIS_802_11_WEP {
        ULONG Length;
        ULONG KeyIndex;
        ULONG KeyLength;
        UCHAR KeyMaterial[1];
} NDIS_802_11_WEP;
*/
    printf("\nNDIS_802_11_WEP\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_WEP,Length));
    printf("    KeyIndex    : %d\n",offsetof(NDIS_802_11_WEP,KeyIndex));
    printf("    KeyLength   : %d\n",offsetof(NDIS_802_11_WEP,KeyLength));
    printf("    KeyMaterial : %d\n",offsetof(NDIS_802_11_WEP,KeyMaterial));

/*
typedef struct NDIS_802_11_KEY {
        ULONG Length;
        ULONG KeyIndex;
        ULONG KeyLength;
        NDIS_802_11_MAC_ADDRESS BSSID;
        NDIS_802_11_KEY_RSC KeyRSC;
        UCHAR KeyMaterial[1];
} NDIS_802_11_KEY;
*/


    printf("\nNDIS_802_11_KEY\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_KEY,Length));
    printf("    KeyIndex    : %d\n",offsetof(NDIS_802_11_KEY,KeyIndex));
    printf("    KeyLength   : %d\n",offsetof(NDIS_802_11_KEY,KeyLength));
    printf("    BSSID       : %d\n",offsetof(NDIS_802_11_KEY,BSSID));
    printf("    KeyRSC      : %d\n",offsetof(NDIS_802_11_KEY,KeyRSC));
    printf("    KeyMaterial : %d\n",offsetof(NDIS_802_11_KEY,KeyMaterial));
/*
typedef struct NDIS_802_11_REMOVE_KEY {
        ULONG Length;
        ULONG KeyIndex;
        NDIS_802_11_MAC_ADDRESS BSSID;
} NDIS_802_11_REMOVE_KEY;
*/
    printf("\nNDIS_802_11_REMOVE_KEY\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_REMOVE_KEY,Length));
    printf("    KeyIndex    : %d\n",offsetof(NDIS_802_11_REMOVE_KEY,KeyIndex));
    printf("    BSSID       : %d\n",offsetof(NDIS_802_11_REMOVE_KEY,BSSID));

/*
typedef struct NDIS_802_11_AI_REQFI {
        USHORT Capabilities;
        USHORT ListenInterval;
        NDIS_802_11_MAC_ADDRESS CurrentAPAddress;
} NDIS_802_11_AI_REQFI;
*/
    printf("\nNDIS_802_11_AI_REQFI\n");
    printf("    Capabilities: %d\n",offsetof(NDIS_802_11_AI_REQFI,Capabilities));
    printf("    ListenInterv: %d\n",offsetof(NDIS_802_11_AI_REQFI,ListenInterval));
    printf("    CurrentAPAdr: %d\n",offsetof(NDIS_802_11_AI_REQFI,CurrentAPAddress));
/*
typedef struct NDIS_802_11_AI_RESFI {
        USHORT Capabilities;
        USHORT StatusCode;
        USHORT AssociationId;
} NDIS_802_11_AI_RESFI;
*/
    printf("\nNDIS_802_11_AI_RESFI\n");
    printf("    Capabilities: %d\n",offsetof(NDIS_802_11_AI_RESFI,Capabilities));
    printf("    StatusCode  : %d\n",offsetof(NDIS_802_11_AI_RESFI,StatusCode));
    printf("    AssociationI: %d\n",offsetof(NDIS_802_11_AI_RESFI,AssociationId));

/*
typedef struct NDIS_802_11_ASSOCIATION_INFORMATION {
        ULONG Length;
        USHORT AvailableRequestFixedIEs;
        NDIS_802_11_AI_REQFI RequestFixedIEs;
        ULONG RequestIELength;
        ULONG OffsetRequestIEs;
        USHORT AvailableResponseFixedIEs;
        NDIS_802_11_AI_RESFI ResponseFixedIEs;
        ULONG ResponseIELength;
        ULONG OffsetResponseIEs;
} NDIS_802_11_ASSOCIATION_INFORMATION;
*/
    printf("\nNDIS_802_11_ASSOCIATION_INFORMATION\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,Length));
    printf("    AvailReqFIEs: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,AvailableRequestFixedIEs));
    printf("    RequestFIEs : %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,RequestFixedIEs));
    printf("    RequestIELen: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,RequestIELength));
    printf("    OffsetReqIEs: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,OffsetRequestIEs));
    printf("    AvailResFIEs: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,AvailableResponseFixedIEs));
    printf("    ResponsFIEs : %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,ResponseFixedIEs));
    printf("    ResponsIELen: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,ResponseIELength));
    printf("    OffsetResIEs: %d\n",offsetof(NDIS_802_11_ASSOCIATION_INFORMATION,OffsetResponseIEs));
/*
typedef struct NDIS_802_11_AUTHENTICATION_ENCRYPTION {
        NDIS_802_11_AUTHENTICATION_MODE AuthModeSupported;
        NDIS_802_11_ENCRYPTION_STATUS EncryptStatusSupported;
} NDIS_802_11_AUTHENTICATION_ENCRYPTION;
*/
    printf("\nNDIS_802_11_AUTHENTICATION_ENCRYPTION\n");
    printf("    AuthModeSup : %d\n",offsetof(NDIS_802_11_AUTHENTICATION_ENCRYPTION,AuthModeSupported));
    printf("    EncrStatusS : %d\n",offsetof(NDIS_802_11_AUTHENTICATION_ENCRYPTION,EncryptStatusSupported));

/*
typedef struct NDIS_802_11_CAPABILITY {
        ULONG Length;
        ULONG Version;
        ULONG NoOfPMKIDs;
        ULONG NoOfAuthEncryptPairSupported;
        NDIS_802_11_AUTHENTICATION_ENCRYPTION
                AuthenticationEncryptionSupported[1];
} NDIS_802_11_CAPABILITY;
*/
    printf("\nNDIS_802_11_CAPABILITY\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_CAPABILITY,Length));
    printf("    Version     : %d\n",offsetof(NDIS_802_11_CAPABILITY,Version));
    printf("    NoOfPMKIDs  : %d\n",offsetof(NDIS_802_11_CAPABILITY,NoOfPMKIDs));
    printf("    NoOfAuthEn. : %d\n",offsetof(NDIS_802_11_CAPABILITY,NoOfAuthEncryptPairSupported));
    printf("    AuthEncrS[] : %d\n",offsetof(NDIS_802_11_CAPABILITY,AuthenticationEncryptionSupported));

/*
typedef struct BSSID_INFO {
        NDIS_802_11_MAC_ADDRESS BSSID;
        NDIS_802_11_PMKID_VALUE PMKID;
} BSSID_INFO;
*/
    printf("\nBSSID_INFO\n");
    printf("    BSSID       : %d\n",offsetof(BSSID_INFO,BSSID));
    printf("    PMKID       : %d\n",offsetof(BSSID_INFO,PMKID));

/*
typedef struct NDIS_802_11_PMKID {
        ULONG Length;
        ULONG BSSIDInfoCount;
        BSSID_INFO BSSIDInfo[1];
} NDIS_802_11_PMKID;
*/
    printf("\nNDIS_802_11_PMKID\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_PMKID,Length));
    printf("    BSSIDInfoC  : %d\n",offsetof(NDIS_802_11_PMKID,BSSIDInfoCount));
    printf("    BSSIDInfo[] : %d\n",offsetof(NDIS_802_11_PMKID,BSSIDInfo));
/*
typedef struct NDIS_802_11_STATUS_INDICATION {
        NDIS_802_11_STATUS_TYPE StatusType;
} NDIS_802_11_STATUS_INDICATION;
*/
    printf("\nNDIS_802_11_STATUS_INDICATION\n");
    printf("    StatusType  : %d\n",offsetof(NDIS_802_11_STATUS_INDICATION,StatusType));

/*
typedef struct PMKID_CANDIDATE {
        NDIS_802_11_MAC_ADDRESS BSSID;
        ULONG Flags;
} PMKID_CANDIDATE;
*/
    printf("\nPMKID_CANDIDATE\n");
    printf("    BSSID       : %d\n",offsetof(PMKID_CANDIDATE,BSSID));
    printf("    Flags       : %d\n",offsetof(PMKID_CANDIDATE,Flags));
/*
typedef struct NDIS_802_11_PMKID_CANDIDATE_LIST {
        ULONG Version;
        ULONG NumCandidates;
        PMKID_CANDIDATE CandidateList[1];
} NDIS_802_11_PMKID_CANDIDATE_LIST;
*/
    printf("\nNDIS_802_11_PMKID_CANDIDATE_LIST\n");
    printf("    Version     : %d\n",offsetof(NDIS_802_11_PMKID_CANDIDATE_LIST,Version));
    printf("    NumCandidate: %d\n",offsetof(NDIS_802_11_PMKID_CANDIDATE_LIST,NumCandidates));
    printf("    CandidateL[]: %d\n",offsetof(NDIS_802_11_PMKID_CANDIDATE_LIST,CandidateList));

/*
typedef struct NDIS_802_11_AUTHENTICATION_REQUEST {
        ULONG Length;
        NDIS_802_11_MAC_ADDRESS Bssid;
        ULONG Flags;
} NDIS_802_11_AUTHENTICATION_REQUEST;
*/
    printf("\nNDIS_802_11_AUTHENTICATION_REQUEST\n");
    printf("    Length      : %d\n",offsetof(NDIS_802_11_AUTHENTICATION_REQUEST,Length));
    printf("    Bssid       : %d\n",offsetof(NDIS_802_11_AUTHENTICATION_REQUEST,Bssid));
    printf("    Flags       : %d\n",offsetof(NDIS_802_11_AUTHENTICATION_REQUEST,Flags));



    return 0 ;
}


